/*
Copyright (C) 2018 - 2019 Taisuke Kobayashi
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/*
localStorage:
key: id。0からの整数の通番。
val: status,statusに応じたデータ
status: 新規 削除 設定 集計
新規,設定日時,集計区分,金額,区分1,区分2,区分3,メモ,新規登録日時
削除,削除日時,削除対象のid
設定,登録日時,年間予算(万円),メール転送数(個数),メールアドレス,メールタイトル
集計,登録日時,対象年,対象月,合計日数,通常合計,経費合計,前払合計,酒合計

日時: 2019,02,09,土,14,46,30,130
新規登録日時: 2019-02-09-土-14-46-30-130 
  設定日時と同じ場合は無し。前日ボタンで設定日時をずらした場合のみ記載。
*/
function Data(){
  this.data = [] // 設定日時,集計区分,金額,区分1,区分2,区分3,メモ,新規登録日時
  this.status_sa = ["新規", "削除", "設定", "集計"] // status string array
  this.key_max = -1
  this.prev_save = null
  this.prev_cnt = 0
  this.shuukei = new Map() // "対象年,対象月", [合計日数,通常合計,経費合計,前払合計,酒合計]
  this.init()
}

Data.prototype.init = function(){
  this.data = []
  var ka = []
  var ls = window.localStorage
  var i
  for(i = 0; i < ls.length; i++){
    var k = parseInt(ls.key(i) )
    if(k > this.key_max) this.key_max = k
    ka.push(k)
  }
  ka.sort( (a, b) => a - b) // sort。数値でsortしたい場合、比較関数を指定する必要有り。
  for(i = 0; i < ka.length; i++){
    var k = ka[i], v = ls.getItem(k), status = v.substr(0, 2)
    if(status == this.status_sa[0]){
      // 新規,2019,02,09,土,14,46,30,130,集計区分,金額,区分1,区分2,区分3,メモ,新規登録日時
      this.data.push(v.substr(3) + kugiri + k)
    }else if(status == this.status_sa[1]){
      // 削除,2019,02,09,土,14,46,30,130,削除対象のid
      var id = v.substr(v.lastIndexOf(",") )
      for(var j = this.data.length -1; j >= 0; j--){
        var d1 = this.data[j]
        if(d1.lastIndexOf(id) == d1.length - id.length)
          this.data.splice(j, 1)
      }
    }else if(status == this.status_sa[2]){
      // 設定,2019,02,09,土,14,46,30,130,設定(コンマ区切りで複数)
      var va = v.split(",")
      // 年間予算(万円), 区分ボタン数, メール転送数, メールアドレス, メールタイトル。
      va_for_settei[0] = parseInt(va[9])
      va_for_settei[1] = parseInt(va[10])
      va_for_settei[2] = parseInt(va[11])
      va_for_settei[3] = va[12]
      va_for_settei[4] = va[13]
    }else if(status == this.status_sa[3]){
      // 0    1    2  3  4  5  6  7  8   9      10     11       12       13       14       15
      // 集計,2019,02,09,土,14,46,30,130,対象年,対象月,合計日数,通常合計,経費合計,前払合計,酒合計
      var va = v.split(",")
      this.shuukei.set( "" + parseInt(va[9]) + kugiri + parseInt(va[10]),
                        [ parseInt(va[11]), parseInt(va[12]), parseInt(va[13]),
                          parseInt(va[14]), parseInt(va[15]) ] )
    }
  }
  this.data.sort();
}

Data.prototype.get_raw = function(){
  var ls = window.localStorage
  var ka = []
  for(i = 0; i < ls.length; i++)
    ka.push(parseInt(ls.key(i) ) )
  ka.sort( (a, b) => b - a) // reverse sort。数値でsortしたい場合、比較関数を指定する必要有り。
  var ra = []
  for(i = 0; i < ka.length; i++)
    ra.push(ka[i] + kugiri + ls.getItem(ka[i]) )
  return ra
}

// 2019,02,09,土,14,46,30,130,集計区分,金額,区分1,区分2,区分3,メモ,新規登録日時
Data.prototype.get = function(){
  return this.data.slice()
}

Data.prototype.make_key = function(){
  this.key_max++
  return this.key_max
}

// 削除,削除日時,削除対象のid
Data.prototype.delete = function(k){
  var ls = window.localStorage
  if(ls.getItem(k) == null){
    alert("キー " + k + " が有りませんでした。何もせずに終了します。")
    return
  }
  var v = this.make_now_str() + kugiri + k
  ls.setItem(this.make_key(), this.status_sa[1] + kugiri + v)
  this.init()
}

// 設定,登録日時,年間予算(万円),メール転送数(個数),メールアドレス,メールタイトル
Data.prototype.put_settei = function(){
  var v = this.make_now_str()
  for(var i = 0; i < va_for_settei.length; i++)
    v += kugiri + va_for_settei[i]
  window.localStorage.setItem(this.make_key(), this.status_sa[2] + kugiri + v)
}

// 集計,登録日時,対象年,対象月,合計日数,通常合計,経費合計,前払合計,酒合計
Data.prototype.put_shuukei_sub = function(key, val){
  var v = this.make_now_str()
  v += kugiri + key
  for(var i = 0; i < val.length; i++)
    v += kugiri + val[i]
  window.localStorage.setItem(this.make_key(), this.status_sa[3] + kugiri + v)
}

// 新規,設定日時,集計区分,金額,区分1,区分2,区分3,メモ,新規登録日時
Data.prototype.put = function(s){
  var v = this.make_date_str() + kugiri + s
  if(date_for_prev != null)
    v += kugiri + this.make_now_str("-")
  var k = this.make_key();
  this.data.push(v + kugiri + k)
  window.localStorage.setItem(k, this.status_sa[0] + kugiri + v)
}

Data.prototype.make_date_str = function(){
  if(date_for_prev == null)
    return this.make_now_str()
  return this.make_prev_str()
}

Data.prototype.make_now_str = function(_kugiri = kugiri){
  var d = new Date()
  return "" +
    d.getFullYear() + _kugiri +
    a0(d.getMonth() +1) + _kugiri + // なぜか0が1月。
    a0(d.getDate() ) + _kugiri +
    dayS[d.getDay()] + _kugiri + // 0:日-6:土 曜日が数字では分かいにくいので。
    a0(d.getHours() ) + _kugiri + 
    a0(d.getMinutes() ) + _kugiri +
    a0(d.getSeconds() ) + _kugiri +
    a00(d.getMilliseconds() )
}

Data.prototype.make_prev_str = function(){
  var d = date_for_prev
  if(d == this.prev_save) this.prev_cnt++
  else this.prev_cnt = 0
  var r = "" +
    d.getFullYear() + kugiri +
    a0(d.getMonth() +1) + kugiri + // なぜか0が1月。
    a0(d.getDate() ) + kugiri +
    dayS[d.getDay()] + kugiri + // 0:日-6:土 曜日が数字では分かいにくいので。
    "23" + kugiri + 
    "59" + kugiri +
    "59" + kugiri +
    a00(this.prev_cnt)
  this.prev_save = d
  return r
}

Data.prototype.put_shuukei = function(key, val){
  var m = this.shuukei
  if(m.has(key) ){
    alert("error: Data.put_shuukei(): 既にキー有り。何もしません。" + key)
    return
  }
  m.set(key, val)
  this.put_shuukei_sub(key, val)
}

Data.prototype.get_shuukei = function(key, prev_month = false){
  var m = this.shuukei
  if(prev_month == false){
    if(m.has(key) )
      return m.get(key)
  }else{
    var a = key.split(",")
    var y = parseInt(a[0]), mo = parseInt(a[1])
    if(mo == 1){
      y--
      mo = 12
    }else{
      mo--
    }
    var k = "" + y + "," + mo
    if(m.has(k) )
      return m.get(k)
  }
  return null
}

Data.prototype.debug_info = function(){
  var m = this.shuukei
  var s = ""
  for(var k of m.keys() )
    s += k + " " + m.get(k) + " | "
  alert(s)
}
